import { BaseController } from '@/api/BaseController';
import { RequestOption } from '@/common/http/types';
import { ANY_OBJECT } from '@/types/generic';
import { TableData } from '@/common/types/table';
import { useUrlBuilder } from '@/common/hooks/useUrl';
import TourProjectGroupPurchaseDetail from '@/types/table/tourProjectGroupPurchaseDetail';
import { TourProjectGroupPurchaseData } from '@/api/generated/tourProjectGroupPurchaseController';
import { API_CONTEXT } from '../config';

const { buildGetUrl } = useUrlBuilder();

export interface TourProjectGroupPurchaseDetailData extends TourProjectGroupPurchaseDetail {
  tourProjectGroupPurchase?: TourProjectGroupPurchaseData;
  __cascade_add_temp_id__?: string | number | undefined;
}

export default class TourProjectGroupPurchaseDetailController extends BaseController {
  static list(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post<TableData<TourProjectGroupPurchaseDetailData>>(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/list', params, httpOptions);
  }
  static view(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.get<TourProjectGroupPurchaseDetailData>(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/view', params, httpOptions);
  }
  static export(params: ANY_OBJECT, fileName: string) {
    return super.download(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/export', params, fileName);
  }
  static import(params: ANY_OBJECT) {
    return super.upload(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/import', params);
  }
  static printUrl(params: ANY_OBJECT) {
    return buildGetUrl(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/print', params);
  }
  static add(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/add', params, httpOptions);
  }
  static update(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/update', params, httpOptions);
  }
  static delete(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/delete', params, httpOptions);
  }
  static deleteBatch(params: ANY_OBJECT, httpOptions?: RequestOption) {
    return super.post(API_CONTEXT + '/app/tourProjectGroupPurchaseDetail/deleteBatch', params, httpOptions);
  }
}
